      subroutine hec_geo
c
c fill geometry correspondence tables for adc channels
c 
c original  July 96
c 13/02/97  M. Lefebvre  correct for Sept 96 new electronics cabling
c
      implicit none
c
c adc channel info common
c
      include'./inc/hec_pad.inc'
c
c user datacard values common
c
      include'./inc/hec_datacard.inc'
c
c local variables
c
      integer ic
      integer i_mod
      integer i_seg
      integer i_pad
      integer i_eta
      integer i_phi
      integer i_z
c
c reset calibration array
c
      call vzero(adc_cal, 5*i_adc_dim)
c
c reset geometry
c
      call vzero(ictodb, 3*i_adc_dim)
      call vzero(ictoph, 3*i_adc_dim)
      call vzero(dbtoic, i_mod_max*i_seg_max*i_pad_max)
      call vzero(phtoic, i_eta_max*i_phi_max*i_z_max)
c
c fill database system correspondence table
c *** should really read database file...
c
      do i_mod = 1, i_mod_max
        do i_seg = 1, i_seg_max
          do i_pad = 1, i_pad_max
            ic = i_pad + (i_seg - 1)*i_pad_max 
     +                 + (i_mod - 1)*i_pad_max*i_seg_max
            ictodb(ic, 1) = i_mod
            ictodb(ic, 2) = i_seg
            ictodb(ic, 3) = i_pad
            dbtoic(i_mod, i_seg, i_pad) = ic
          enddo
        enddo
      enddo
c
c check beam period and fill physics system correspondence tables
c
      if (irunpd .eq. 1) then
c
c May 96
c
c fill database system correspondence table
c *** should really read database file...
c
        do i_mod = 1, i_mod_max
          do i_seg = 1, i_seg_max
            do i_pad = 1, i_pad_max
              ic = i_pad + (i_seg - 1)*i_pad_max 
     +        + (i_mod - 1)*i_pad_max*i_seg_max
              ictodb(ic, 1) = i_mod
              ictodb(ic, 2) = i_seg
              ictodb(ic, 3) = i_pad
              dbtoic(i_mod, i_seg, i_pad) = ic
            enddo
          enddo
        enddo
c
        i_adc_used = 48
c
        i_mod_used = 1     
        i_seg_used = 3 
        i_pad_used = 16
c
        i_eta_used = 10
        i_phi_used = 2
        i_z_used   = 3
c
c fill table
c
        do i_mod = 1, i_mod_used
          do i_seg = 1, i_seg_used
            do i_pad = 1, i_pad_used
              ic = dbtoic(i_mod, i_seg, i_pad)
c
              i_eta = (i_pad - 1)/2 + i_seg
              i_phi = 2*(i_mod_used - i_mod + 1) - mod(i_pad, 2)
              i_z   = i_seg 
c
              ictoph(ic, 1) = i_eta
              ictoph(ic, 2) = i_phi
              ictoph(ic, 3) = i_z
              phtoic(i_eta, i_phi, i_z) = ic
            enddo
          enddo
        enddo
      elseif (irunpd .eq. 2) then
c
c July 96
c
c fill database system correspondence table
c *** should really read database file...
c
        do i_mod = 1, i_mod_max
          do i_seg = 1, i_seg_max
            do i_pad = 1, i_pad_max
              ic = i_pad + (i_seg - 1)*i_pad_max 
     +        + (i_mod - 1)*i_pad_max*i_seg_max
              ictodb(ic, 1) = i_mod
              ictodb(ic, 2) = i_seg
              ictodb(ic, 3) = i_pad
              dbtoic(i_mod, i_seg, i_pad) = ic
            enddo
          enddo
        enddo
c
        i_adc_used = 128
c
        i_mod_used = 2
        i_seg_used = 5 
        i_pad_used = 16
c
        i_eta_used = 12
        i_phi_used = 4
        i_z_used   = 5
c
c fill table
c
        i_mod = 1
        do i_seg = 1, i_seg_used
          do i_pad = 1, i_pad_used
            ic = dbtoic(i_mod, i_seg, i_pad)
c
            i_eta = (i_pad - 1)/2 + i_seg
            i_phi = 2*(i_mod_used - i_mod + 1) - mod(i_pad, 2)
            if (i_seg .ge. 4) i_phi = i_phi - 1 !back of module 1 in middle
            i_z   = i_seg 
c
            ictoph(ic, 1) = i_eta
            ictoph(ic, 2) = i_phi
            ictoph(ic, 3) = i_z
            phtoic(i_eta, i_phi, i_z) = ic
          enddo
        enddo
c
        i_mod = 2
        do i_seg = 1, 3
          do i_pad = 1, i_pad_used
            ic = dbtoic(i_mod, i_seg, i_pad)
c
            i_eta = (i_pad - 1)/2 + i_seg
            i_phi = 2*(i_mod_used - i_mod +1) - mod(i_pad, 2)
            i_z   = i_seg 
c
            ictoph(ic,1) = i_eta
            ictoph(ic,2) = i_phi
            ictoph(ic,3) = i_z
            phtoic(i_eta, i_phi, i_z) = ic
          enddo
        enddo
      else
c
c September 96
c
c fill database system correspondence table
c *** should really read database file...
c see hec_pad.inc for info on new electronics cabling
c
        do i_mod = 1, i_mod_max
          do i_seg = 1, i_seg_max
            do i_pad = 1, i_pad_max
              ic = i_pad + (i_seg - 1)*i_pad_max 
     +        + (i_mod - 1)*i_pad_max*i_seg_max
c 
c correct for the new electronics cabling
c see hec_pad.inc for info on new electronics cabling
c
              if (ic .eq. 93) then
                ic=173
                ictodb(ic, 1) = i_mod
                ictodb(ic, 2) = i_seg
                ictodb(ic, 3) = i_pad
              elseif (ic .eq. 107) then
                ic=172
                ictodb(ic, 1) = i_mod
                ictodb(ic, 2) = i_seg
                ictodb(ic, 3) = i_pad
              elseif (ic .eq. 121) then
                ic=172
              elseif (ic .eq. 135) then
                ic=169
                ictodb(ic, 1) = i_mod
                ictodb(ic, 2) = i_seg
                ictodb(ic, 3) = i_pad
              elseif (ic .eq. 149) then
                ic=169
              else
                ictodb(ic, 1) = i_mod
                ictodb(ic, 2) = i_seg
                ictodb(ic, 3) = i_pad
              endif
              dbtoic(i_mod, i_seg, i_pad) = ic
            enddo
          enddo
        enddo
c
        i_adc_used = 173
c
        i_mod_used = 2
        i_seg_used = 5 
        i_pad_used = 16
c
        i_eta_used = 12
        i_phi_used = 4
        i_z_used   = 5
c
c fill table
c
        do i_mod = 1, i_mod_used
          do i_seg = 1, i_seg_used
            do i_pad = 1, i_pad_used
              ic = dbtoic(i_mod, i_seg, i_pad)
c
              i_eta = (i_pad - 1)/2 + i_seg
              i_phi = 2*(i_mod_used - i_mod + 1) - mod(i_pad, 2)
c 
c correct for the new electronics cabling
c see hec_pad.inc for info on new electronics cabling
c
              if (i_eta .eq. 7 .and. i_phi .eq. 1) then
                if (i_seg .eq. 1) then
                  i_z = 1
                elseif (i_seg .le. 3) then
                  i_z = 2
                else
                  i_z = 3
                endif
              else
                i_z = i_seg 
              endif
c
              ictoph(ic, 1) = i_eta
              ictoph(ic, 2) = i_phi
              ictoph(ic, 3) = i_z
              phtoic(i_eta, i_phi, i_z) = ic
            enddo
          enddo
        enddo
      endif
c
      end
        
